require "player"
require "lib/light"
require "particles"
     --gamestates are menu, pause,playing, gameover, and win   
	gamestate = "playing"
	 ---enemy code
	 enemy = {}
	 enemies_controller = {}
	 enemies_controller.enemies = {}
	 enemies_controller.image = love.graphics.newImage("alien.png")
     love.graphics.setDefaultFilter('nearest', 'nearest')

--bullet collision
function checkCollisions(enemies, bullets)
  if gamestate == "playing" then
  for i, e in ipairs(enemies) do
    for _, b in pairs(bullets) do
      if b.y <= e.y + e.height and b.x > e.x and b.x < e.x + e.width then
        particle_systems:spawn(e.x,e.y)
		table.remove(enemies, i)
		table.remove(bullets)
      end
    end
  end
 end
end
--enemy to player collision
  function checkCollisionsDead(enemies)
    if gamestate == "playing" then
  for i, e in ipairs(enemies) do
      if player.y <= e.y + e.height and player.x > e.x and player.x < e.x + e.width then
        gamestate = "gameover"
      end
  end
  end
end

function love.load()
    local music = love.audio.newSource("Community_Theme_Song_8-bit_(At_Least_It_Was_Here).mp3")
    music:setLooping(true)
	love.audio.play(music)
	--Lighting
	 lightWorld = love.light.newWorld()
	 lightWorld.setAmbientColor(100,100,100)
	 lightLight = lightWorld.newLight(0, 0, 255,255,255, 800)
	 playerRec = lightWorld.newRectangle(0, 0, 85, 20)
	 --spawning enemies
	 for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,200)
	end
	for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,100)
	end
	for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,0)
	end
	for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,-100)
	end
	for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,-200)
	end
	for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,-300)
	end
	for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,-400)
	end
	for i=0, 7 do
	 enemies_controller:spawnEnemy(i * 100,-500)
	end
	bg = love.graphics.newImage("background.png")
end

function enemies_controller:spawnEnemy(xx,yy)
     if gamestate == "playing" then
	 enemy = {}
	 enemy.x = xx
	 enemy.y = yy
	 enemy.height = 50
	 enemy.width = 100
	 enemy.bullets = {}
	 enemy.cooldown = 20
	 enemy.speed = 20
	 table.insert(self.enemies, enemy)
	 end
end
function enemy:fire()
 if gamestate == "playing" then   
   if self.cooldown <= 0 then
   self.cooldown = 20
   bullet = {}
   bullet.x = self.x
   bullet.y = self.y
   table.insert(self.bullets, bullet)
   end
   end
end
function love.update(dt)
      love.window.setTitle("Space Invaders (FPS:" .. love.timer.getFPS() .. ")")
	  if gamestate == "playing" then
	 player_update(dt)
	 particle_systems:update(dt)
	 lightLight.setPosition(390,280)
	 playerRec.setPosition(player.x,player.y)
	 if #enemies_controller.enemies == 0 then
	 gamestate = "gamewin"
	 end
	 for _,e in pairs(enemies_controller.enemies) do
	      if e.y >= love.graphics.getHeight() then
		       gamestate = "gameover"
		  end
		  e.y = e.y + enemy.speed * dt
	 end
	 checkCollisions(enemies_controller.enemies, player.bullets)
	 checkCollisionsDead(enemies_controller.enemies)
	 particle_systems:cleanup()
	 end
end
function love.draw()
     if gamestate == "playing" then
	 
	 lightWorld.update()
	 love.graphics.setColor(255, 255, 255)
     love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
	 	  love.graphics.draw(bg,0,0,0,4)
	 lightWorld.drawShadow()
	 lightWorld.drawShine()
	 love.graphics.setColor(255,255,255)
	 particle_systems:draw()
	 ----------------------------------
	--actualstuff
	 player_draw()
	 love.graphics.setColor(165,255,127)
	 love.graphics.polygon("fill", playerRec.getPoints())
	 for _,e in pairs(enemies_controller.enemies) do
	      love.graphics.setColor(255,255,255)
		  love.graphics.draw(enemies_controller.image, e.x, e.y, 0, 1.5)
	 end
      
	  elseif gamestate == "gameover" then
                if love.keyboard.isDown("r") then
				      gamestate = "playing"
				end
	  elseif gamestate == "gamewin" then 
           love.graphics.setColor(255,255,255)	      
		  love.graphics.print("YOU WON",200,200,0,5)
		   love.graphics.print("10/10", 350, 300, 0, 5)  
	  end

	  
end